/*********************************************************************
*                SEGGER Microcontroller GmbH & Co. KG                *
*                        The Embedded Experts                        *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2016 SEGGER Microcontroller GmbH & Co. KG         *
*                                                                    *
*     Internet: segger.com   Support: support_embos@segger.com       *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system for microcontrollers      *
*                                                                    *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: 4.16                                             *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File    : OptLib_Heap.c
Purpose : Heap low level functions for KPIT Optimized library
--------  END-OF-HEADER  ---------------------------------------------
*/

#include <stdlib.h>

/*********************************************************************
*
*       External data
*
**********************************************************************
*/
extern char __heap_start__, __heap_end__;

/*********************************************************************
*
*       Prototypes
*
**********************************************************************
*/
char* _top_of_heap(void);
void heap_initialise(void);

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/
char* _heap_of_memory   = NULL;
char* _last_heap_object = NULL;

/*********************************************************************
*
*       Global functions
*
**********************************************************************
*/

/*********************************************************************
*
*       _top_of_heap()
*/
char* _top_of_heap(void) {
  return (&__heap_end__);
}

/*********************************************************************
*
*       heap_initialise()
*/
void heap_initialise(void) {
  _heap_of_memory   = (char*) &__heap_start__;
  _last_heap_object = (char*) &__heap_start__;
  return;
}

/****** End Of File *************************************************/
